const net = require('net');
const expect = require('chai').expect;
const TcpEndpoint = require('../src/endpoint/tcp');
const Repository = require('../src/repository');

const flow = [
    [ /* Packet 57 */
        0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x28,
        0xa1, 0x00, 0x00, 0x00, 0x67, 0x61, 0x6d, 0x65,
        0x5f, 0x6d, 0x6f, 0x64, 0x65, 0x3d, 0x33, 0x3b,
        0x6d, 0x61, 0x78, 0x70, 0x6c, 0x3d, 0x34, 0x3b,
        0x6d, 0x6f, 0x64, 0x3d, 0x42, 0x46, 0x45, 0x4d,
        0x50, 0x3b, 0x6e, 0x61, 0x74, 0x69, 0x6f, 0x6e,
        0x3d, 0x64, 0x65, 0x3b, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x31, 0x3b, 0x70, 0x61, 0x73, 0x73,
        0x77, 0x6f, 0x72, 0x64, 0x3d, 0x30, 0x3b, 0x70,
        0x6c, 0x61, 0x79, 0x65, 0x72, 0x73, 0x3d, 0xa7,
        0x28, 0x31, 0x30, 0x29, 0x1b, 0x44, 0x65, 0x76,
        0x6f, 0x6e, 0x46, 0x72, 0x6f, 0x73, 0x63, 0x68,
        0x1c, 0xa7, 0x28, 0x2d, 0x31, 0x29, 0x1b, 0x3b,
        0x73, 0x65, 0x72, 0x76, 0x65, 0x72, 0x5f, 0x6e,
        0x61, 0x6d, 0x65, 0x3d, 0x53, 0x46, 0x47, 0x20,
        0x28, 0x44, 0x65, 0x76, 0x6f, 0x6e, 0x46, 0x72,
        0x6f, 0x73, 0x63, 0x68, 0x29, 0x3b, 0x73, 0x65,
        0x72, 0x76, 0x65, 0x72, 0x5f, 0x70, 0x6f, 0x72,
        0x74, 0x3d, 0x35, 0x38, 0x32, 0x38, 0x32, 0x3b,
        0x76, 0x6d, 0x61, 0x6a, 0x3d, 0x31, 0x3b, 0x76,
        0x6d, 0x69, 0x6e, 0x3d, 0x33, 0x3b, 0x76, 0x74,
        0x79, 0x70, 0x65, 0x3d, 0x66],
    [ /* Packet 98 */
        0x00, 0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x32],
    [ /* Packet 100 */
        0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x01, 0x60,
        0x28, 0x00, 0x00, 0x00, 0x70, 0x6c, 0x61, 0x79,
        0x65, 0x72, 0x73, 0x3d, 0xa7, 0x28, 0x31, 0x30,
        0x29, 0x1b, 0x44, 0x65, 0x76, 0x6f, 0x6e, 0x46,
        0x72, 0x6f, 0x73, 0x63, 0x68, 0x1c, 0xa7, 0x28,
        0x2d, 0x31, 0x29, 0x1b, 0x2c, 0x20, 0x67, 0x72,
        0x69, 0x6d, 0x62, 0x6f],
    [ /* Packet 133 */
        0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x33],
    [ /* Packet 135 */
        0x00, 0x00, 0x00, 0x04, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x32],
    [ /* Packet 145 */
        0x00, 0x00, 0x00, 0x05, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x33],
    [ /* Packet 155 */
        0x00, 0x00, 0x00, 0x06, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x32],
    [ /* Packet 157 */
        0x00, 0x00, 0x00, 0x07, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x33],
    [ /* Packet 159 */
        0x00, 0x00, 0x00, 0x08, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x32],
    [ /* Packet 169 */
        0x00, 0x00, 0x00, 0x09, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x33],
    [ /* Packet 171 */
        0x00, 0x00, 0x00, 0x0a, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x32],
    [ /* Packet 192 */
        0x00, 0x00, 0x00, 0x0b, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x33],
    [ /* Packet 194 */
        0x00, 0x00, 0x00, 0x0c, 0x00, 0x00, 0x01, 0xb8,
        0x33, 0x00, 0x00, 0x00, 0x70, 0x6c, 0x61, 0x79,
        0x65, 0x72, 0x73, 0x3d, 0xa7, 0x28, 0x31, 0x30,
        0x29, 0x1b, 0x44, 0x65, 0x76, 0x6f, 0x6e, 0x46,
        0x72, 0x6f, 0x73, 0x63, 0x68, 0x1c, 0xa7, 0x28,
        0x2d, 0x31, 0x29, 0x1b, 0x2c, 0x20, 0x67, 0x72,
        0x69, 0x6d, 0x62, 0x6f, 0x2c, 0x20, 0x54, 0x65,
        0x63, 0x68, 0x6e, 0x6f, 0x62, 0x6f, 0x79],
    [ /* Packet 214 */
        0x00, 0x00, 0x00, 0x0d, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x34],
    [ /* Packet 216 */
        0x00, 0x00, 0x00, 0x0e, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x33],
    [ /* Packet 265 */
        0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x34],
    [ /* Packet 267 */
        0x00, 0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x33],
    [ /* Packet 281 */
        0x00, 0x00, 0x00, 0x11, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x34],
    [ /* Packet 283 */
        0x00, 0x00, 0x00, 0x12, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x33],
    [ /* Packet 293 */
        0x00, 0x00, 0x00, 0x13, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x34],
    [ /* Packet 295 */
        0x00, 0x00, 0x00, 0x14, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x33],
    [ /* Packet 323 */
        0x00, 0x00, 0x00, 0x15, 0x00, 0x00, 0x00, 0x58,
        0x07, 0x00, 0x00, 0x00, 0x6e, 0x75, 0x6d, 0x70,
        0x6c, 0x3d, 0x34],
    [ /* Packet 325 */
        0x00, 0x00, 0x00, 0x16, 0x00, 0x00, 0x01, 0xe8,
        0x39, 0x00, 0x00, 0x00, 0x70, 0x6c, 0x61, 0x79,
        0x65, 0x72, 0x73, 0x3d, 0xa7, 0x28, 0x31, 0x30,
        0x29, 0x1b, 0x44, 0x65, 0x76, 0x6f, 0x6e, 0x46,
        0x72, 0x6f, 0x73, 0x63, 0x68, 0x1c, 0xa7, 0x28,
        0x2d, 0x31, 0x29, 0x1b, 0x2c, 0x20, 0x67, 0x72,
        0x69, 0x6d, 0x62, 0x6f, 0x2c, 0x20, 0x54, 0x65,
        0x63, 0x68, 0x6e, 0x6f, 0x62, 0x6f, 0x79, 0x2c,
        0x20, 0x43, 0x65, 0x72, 0x61]
].map(packet => Buffer.of(...packet));


describe('TCP API', function () {
    let repository;
    let tcpEndpoint;
    let interval;

    beforeEach((done) => {
        this.timeout(1000);

        repository = new Repository();
        tcpEndpoint = new TcpEndpoint(repository);
        tcpEndpoint.tcpHost.listen({ host: '127.0.0.1', port: 0 }, done);
        clearInterval(repository.timeout);
    });

    it('should create new sessions', function (done) {
        this.timeout(1000);

        const client = new net.Socket();
        const { address, port } = tcpEndpoint.tcpHost.address();
        const expectations = {
            1() {
                const sessions = repository.getSessions();
                expect(sessions).to.have.lengthOf(1);
                expect(sessions[0]).to.deep.include({
                    server_addr: '127.0.0.1',
                    inet: true
                });
            },
            3() {
                const sessions = repository.getSessions();
                expect(sessions).to.have.lengthOf(1);
                expect(sessions[0]).to.deep.include({
                    server_name: 'SFG (DevonFrosch)',
                    server_addr: '127.0.0.1',
                    players: ['DevonFrosch', 'grimbo'],
                    numpl: 2
                });
            },
            13() {
                const sessions = repository.getSessions();
                expect(sessions).to.have.lengthOf(1);
                expect(sessions[0]).to.deep.include({
                    server_name: 'SFG (DevonFrosch)',
                    server_addr: '127.0.0.1',
                    players: ['DevonFrosch', 'grimbo', 'Technoboy'],
                    numpl: 3
                });
            },
            24() {
                const sessions = repository.getSessions();
                expect(sessions).to.have.lengthOf(1);
                expect(sessions[0]).to.deep.include({
                    server_name: 'SFG (DevonFrosch)',
                    server_addr: '127.0.0.1',
                    players: ['DevonFrosch', 'grimbo', 'Technoboy', 'Cera'],
                    numpl: 4
                });
            }
        };

        client.connect(port, address, () => {
            client.setNoDelay(true);

            let i = 0;
            interval = setInterval(() => {
                if (i < flow.length) {
                    client.write(flow[i]);
                }
                // check if there is any expectation bound
                if (i in expectations) {
                    expectations[i]();
                }
                i++;
                if (i >= flow.length) {
                    client.end();
                    clearInterval(interval);
                    done();
                }
            }, 10);
        });
    });

    it('should not spawn zombie sessions (regression test #9)', function (done) {
        this.timeout(1000);

        const client = new net.Socket();
        const { address, port } = tcpEndpoint.tcpHost.address();

        client.connect(port, address, () => {
            client.setNoDelay(true);
            client.write(flow[0]);
        });

        let connected = false;
        setTimeout(() => {
            connected = true;
            expect(repository.getSessions()).to.have.lengthOf(1);
            repository.alive('127.0.0.1', false);
        }, 100);

        setTimeout(() => {
            client.end(flow[1]);
        }, 200);

        setTimeout(() => {
            expect(connected).to.be.true;
            expect(repository.getSessions()).to.be.empty;
            done();
        }, 300);
    });

    afterEach((done) => {
        this.timeout(1000);

        tcpEndpoint.tcpHost.close(done);
    });
});
